shader_type canvas_item;
render_mode blend_mix,unshaded;

uniform sampler2D iChannel0:hint_albedo; //texture

varying flat float texture_tile_id;

void vertex(){
  float scale=INSTANCE_CUSTOM.z;
  scale=max(scale,0.00001);
  VERTEX*=1.5*scale; //apply scale
  texture_tile_id=max(INSTANCE_CUSTOM.w-1.,0.); // -1.because I do +1 in particle logic
}

int get_index(in ivec2 idx, in ivec2 size){
    return (idx.x%size.x)+idx.y*size.x;
}

ivec2 get_index2(in int idx, in ivec2 size){
    return ivec2(idx%size.x,idx/size.x);
}

void fragment(){
    vec2 uv=UV;
    ivec2 tile_texture_map_size=textureSize(iChannel0,0).xy/32;
    ivec2 tid=get_index2(int(texture_tile_id),tile_texture_map_size);
    
    vec2 tuv=uv*1./vec2(tile_texture_map_size)+vec2(tid)*1./vec2(tile_texture_map_size);
    tuv+=vec2(1./64.)/vec2(tile_texture_map_size); // maybe tilemap broken, need shift by 1 pixel to remove black border
    
    COLOR=textureLod(iChannel0,tuv,0.);
}
