shader_type canvas_item;
render_mode blend_mix,unshaded;

uniform sampler2D iChannel0:hint_albedo; //texture
uniform sampler2D iChannel1; //data buffer with pos and vel
uniform sampler2D iChannel2; //data buffer with initial pos, scale and tile id

varying flat float texture_tile_id;

int get_index(in ivec2 idx, in ivec2 size){
    return (idx.x%size.x)+idx.y*size.x;
}

ivec2 get_index2(in int idx, in ivec2 size){
    return ivec2(idx%size.x,idx/size.x);
}

void vertex(){
  ivec2 data_size=textureSize(iChannel1,0).xy;
  // INSTANCE_CUSTOM.x has index of this particle
  vec4 INSTANCE_CUSTOM_local=texelFetch(iChannel1,get_index2(int(INSTANCE_CUSTOM.x),data_size),0); //get data
  vec4 data2=texelFetch(iChannel2,get_index2(int(INSTANCE_CUSTOM.x),data_size),0); //get data2
  float scale=data2.z;
  scale=max(scale,0.00001);
  vec2 pos=INSTANCE_CUSTOM_local.zw;
  VERTEX*=1.5*scale; //apply scale
  VERTEX+=pos;
  texture_tile_id=max(data2.w,0.);
}

void fragment(){
    vec2 uv=UV;
    ivec2 tile_texture_map_size=textureSize(iChannel0,0).xy/32;
    ivec2 tid=get_index2(int(texture_tile_id),tile_texture_map_size);
    
    vec2 tuv=uv*1./vec2(tile_texture_map_size)+vec2(tid)*1./vec2(tile_texture_map_size);
    tuv+=vec2(1./64.)/vec2(tile_texture_map_size); // maybe tilemap broken, need shift by 1 pixel to remove black border
    
    COLOR=textureLod(iChannel0,tuv,0.);
}
